<Query Kind="Program">
  <Namespace>System.Threading.Tasks</Namespace>
</Query>

static Task<string> GetContent (Uri uri) => Task.Delay (1000).ContinueWith (_ => "slow");

static Dictionary<Uri, string> _cache = new Dictionary<Uri, string>();

static async Task<string> GetCachedContentAsync (Uri uri)
{
	string result;
	lock (_cache)
	{
		if (_cache.TryGetValue (uri, out result)) return result;
		return _cache [uri] = await GetContent (uri);
	}
}