<Query Kind="Program">
  <Namespace>System.Threading.Tasks</Namespace>
</Query>

async static Task Main()
{
	(await GetCachedContentAsync (new Uri ("http://foo"))).Dump();	
}

static Task<string> GetContent (Uri uri) => Task.Delay (1000).ContinueWith (_ => "slow");

static Dictionary<Uri, Task<string>> _cache = new Dictionary<Uri, Task<string>>();

static Task<string> GetCachedContentAsync (Uri uri)
{
	Task<string> result;
	lock (_cache)
	{
		if (_cache.TryGetValue (uri, out result)) return result;
		return _cache [uri] = GetContent (uri);
	}
}

// Is this async?