<Query Kind="Program">
  <Namespace>System.Threading.Tasks</Namespace>
</Query>

async Task Main()
{
	var cts = new CancellationTokenSource (2500);
	int primes = await Task.Run (() => GetPrimes (1, 5000000, cts.Token));
	primes.Dump();
}

int GetPrimes (int start, int end, CancellationToken cancelToken)
{
	return ParallelEnumerable.Range (start, end - start)
		.WithCancellation (cancelToken)
		.Count (n => Enumerable.Range (2, (int)Math.Sqrt (n)).All (i => n % i > 0));
}
